// Persistence Of Vision raytracer version 1.0.

// inc. file for mountb.pov from Paul Cotterill
// This is not to be taken seriously as a realistic bird.
// In close-up it is a crude wooden model,
// in the context of the finished picture it works O.K.
// I was using this as an opportunity to learn about csg.
// I'm sure there are better and easier ways of doing this.

#include "shapes.inc"
#include "shapes2.inc"
#include "colors.inc"
#include "textures.inc"

#declare text = texture 
	{
	
	Sandalwood
   }

#declare wing1 = 
	object {
	intersection {
   quadric { Ellipsoid scale < 3.0 0.5 1.5 >}
		
	box {UnitBox scale <2.5 2.5 2.5> 
		translate <0.3 0 0>}	
	}
   texture {
      text
   }
}

#declare body =
	object {
	intersection {
   quadric { Ellipsoid scale < 1.0 1.0 4.0 >}
		
	box {UnitBox scale <3.8 3.8 3.8> 
		}	
	}
   texture {
      text
   }
}

#declare head =
	object {
	intersection {
   quadric { Ellipsoid scale < 0.5 0.5 0.8 >}
		
	box {UnitBox scale <0.85 0.85 0.85> 
		}	
	}
   texture {
      text
   }
}

#declare tail1 =
	object {
	intersection {
   quadric { Ellipsoid scale < 1.2 0.03 3 >}
		
	box {UnitBox scale <2.5 2.5 2.5> 
		translate <0 0 -2.5>}	
	}
   texture {
      text
   }
	
}

#declare wingtip =
	object {
	intersection {
   quadric { Ellipsoid scale < 3.0 0.5 1.5 >}
		
	box {UnitBox  
		translate <1.2 1.3 1.25>}	
	}
   texture {
      text
   }
	
	
}

#declare tailtip =
	object {
	intersection {
   quadric { Ellipsoid scale < 1.0 0.1 4.0 >}
		
	box {UnitBox scale <2.0 2.0 2.0> 
		translate < 0 0 -5.6>}	
	}
   texture {
      text
   }
}	

#declare bird =

composite {
object {
	wing1
	
	
	
	translate <2 4 0>
}

object {
	wing1
	rotate <0 180 0>
	translate <-2 4 0>
}

object {
	body
	translate <0 3.7 0>
}

object {
	head

	translate < 0 3.7 3.6>
}

object {
	tail1
	rotate < 0 -180 0>
	translate < 0 3.6 -4.2>
	
}



object {
	wingtip
	translate < 3.0 3.4 -0.3 >
}

object {
	wingtip
	translate < 3.3 3.4 -0.6 >
}

object {
	wingtip
	translate < 3.5 3.4 -1.2 >
}

object {
	wingtip
	translate < 3.3 3.4 -1.8 >
}

object {
	wingtip
	rotate <180 0 0>
	rotate <0 180 0>
	translate < -3.3 4.2 -1.8 >
}

object {
	wingtip
	rotate <180 0 0>
	rotate <0 180 0>
	translate < -3.5 4.2 -1.2 >
}

object {
	wingtip
	rotate <180 0 0>
	rotate <0 180 0>
	translate < -3.3 4.2 -0.6 >
}

object {
	wingtip
	rotate <180 0 0>
	rotate <0 180 0>
	translate < -3.0 4.0 -0.3 >
}

object {
	tailtip
	translate < 0 3.6 -0.45>
	rotate < 0 0 0 >
}

object {
	tailtip
	translate < 0 3.6 -0.4>
	rotate < 0 10 0 >
}

object {
	tailtip
	translate < 0 3.6 -0.35>
	rotate < 0 12.5 0 >
}

object {
	tailtip
	translate < 0 3.6 -0.4>
	rotate < 0 -10 0 >
}

object {
	tailtip
	translate < 0 3.6 -0.35>
	rotate < 0 -12.5 0 >
}

bounded_by {
	sphere {<0.0 0.0 0.0> 15.0 }
	}
}

